[user]
	name = Sahil Kabra
	email = sahil.kabra@gmail.com
[url "https://"]
    insteadOf = git://
[merge]
    # Rebase only if ff possible, never merge
    ff = only
[status]
    # Show all files in a newly added folder
    showUntrackedFiles = all
[diff]
    tool = icdiff
    renames = 0
    renamelimit = 0
[difftool]
    prompt = false
[difftool "icdiff"]
    cmd = /usr/local/bin/icdiff --line-number $LOCAL $REMOTE
[pager]
    difftool = true
[merge]
    tool = vimdiff
[mergetool]
    prompt = false
[alias]
    # new workflow - in line with linux commands
    #
    # list branches
    lsb = !"git br"
    lsba = !"git br -a"

    # list commits
    lsc = !"git logp --no-merges"
    lsca = !"git log --no-merges"
    lscm = !"git mini --no-merges"
    lscc = !"git show --name-only"

    # Better log views
    lg1 = !"git lg1-specific"
    lg2 = !"git lg2-specific"
    lg3 = !"git lg3-specific"
    lg1-specific = log --graph --abbrev-commit --decorate --format=format:'%C(bold blue)%h%C(reset) - %C(bold green)(%ar)%C(reset) %C(normal)%s%C(reset) %C(dim normal)- %an%C(reset)%C(bold yellow)%d%C(reset)'
    lg2-specific = log --graph --abbrev-commit --decorate --format=format:'%C(bold blue)%h%C(reset) - %C(bold cyan)%aD%C(reset) %C(bold green)(%ar)%C(reset)%C(bold yellow)%d%C(reset)%n''          %C(normal)%s%C(reset) %C(dim normal)- %an%C(reset)'
    lg3-specific = log --graph --abbrev-commit --decorate --format=format:'%C(bold blue)%h%C(reset) - %C(bold cyan)%aD%C(reset) %C(bold green)(%ar)%C(reset) %C(bold cyan)(committed: %cD)%C(reset) %C(bold yellow)%d%C(reset)%n''          %C(normal)%s%C(reset)%n''          %C(dim normal)- %an <%ae> %C(reset) %C(dim normal)(committer: %cn <%ce>)%C(reset)'
    logp = log --oneline --graph --decorate --format=format:'%C(blue)%h%C(reset) - %C(dim green)%ar%C(reset) %s %C(dim green)- %an%C(reset) %C(dim red)%d%C(reset)'
    # Shortcuts
    br = branch
    st = status -sb
    co = checkout
    discard = checkout --
    rb = rebase
    cot = checkout --track
    plr = pull --rebase
    rvf = review --finish
    rvc = review --download
    crp = cherry-pick
    rvw = review
    wt = worktree
    # Usability
    coa = commit --amend
    coh = co HEAD .
    coane = !"git coa --no-edit"
    undo = reset --soft HEAD~1
    unstage = reset HEAD
    last = log -1
    mini = !"git logp -10"
    comnv = commit --no-verify
    brp = !"git br | grep $1 | xargs git br -d"
    brmd = !"git br --merged | grep -v master | xargs git br -d"
    wtrm = worktree remove
    wtls = worktree list
[push]
    default = simple
[credential]
    helper = cache --timeout 43200
[core]
    excludesFile = /Users/sahil.kabra/.config/gitignore
    editor = vim
[init]
    defaultBranch = master
[worktree]
    guessRemote = true
